## ur rtde-1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
if (POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# options
option(CODE "Build primary libraries" ON)
option(EXAMPLES "Build example executables." ON)
option(PYTHON_BINDINGS "Build python bindings for libraries" ON)
option(USE_WERROR "Use more strict compile flags" OFF)
option(WINDOWS_INSTALLER "Use this to generate a windows installer" OFF)
option(BUILD_STATIC "Use this option to build the library STATIC" OFF)

set(BUILD_TYPE SHARED)
if(BUILD_STATIC)
	set(BUILD_TYPE STATIC)
endif()

if(NOT DEFINED DOC)
	set(DOC OFF CACHE STRING
			"The documentation type to generate." FORCE)
endif()

# disable base languages
unset(PROJECT_LANGUAGES)

if(${CODE})
	set(PROJECT_LANGUAGES ${PROJECT_LANGUAGES} C CXX)
	set(CMAKE_CXX_STANDARD 11)
	set(CMAKE_CXX_STANDARD_REQUIRED ON)
	set(CMAKE_CXX_EXTENSIONS OFF)
	if(${USE_WERROR} AND NOT DEFINED MSVC)
		set(WALL "-Wall -Wno-strict-aliasing -Wno-unused-function -Wno-pragmas")
		set(WERROR "-Werror")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WALL} ${WERROR}")
		message(STATUS "CompileFlags: ${CMAKE_CXX_FLAGS}")
	endif()
	if(DEFINED WIN32)
		ADD_DEFINITIONS(-D_WIN32_WINNT=0x0A00)
		ADD_DEFINITIONS(-DBOOST_ALL_NO_LIB)
	endif()
endif()

project(ur_rtde VERSION 1.3.2 LANGUAGES ${PROJECT_LANGUAGES})
set(PROJECT_VERSION_SUFFIX "") # alpha/beta/rc, e.g. "-rc0"
set(PROJECT_VERSION "${PROJECT_VERSION}${PROJECT_VERSION_SUFFIX}")
set(PROJECT_AUTHOR "Anders Prier Lindvig")
set(PROJECT_COPYRIGHT "2019")
set(PROJECT_MAIL "anpl@mmmi.sdu.dk")

if(${CODE})
	set(Boost_USE_MULTITHREAD ON)
	if(WINDOWS_INSTALLER)
		set(Boost_USE_STATIC_LIBS ON)
	endif()
	find_package(Boost REQUIRED COMPONENTS system thread)
	find_package(Threads)

	if(${PYTHON_BINDINGS})
		# This is required to find python site-packages for installation of ur_rtde python bindings.
		if(NOT PYBIND11_PYTHON_VERSION)
			set(PYBIND11_PYTHON_VERSION "" CACHE STRING "Python version to use for compiling modules")
		endif()
		set(Python_ADDITIONAL_VERSIONS 3.9 3.8 3.7 3.6 3.5 3.4)
		find_package(PythonLibsNew ${PYBIND11_PYTHON_VERSION} REQUIRED)

		if(${CMAKE_VERSION} VERSION_LESS 3.11)
			# pybind11 must be found from submodule
			add_subdirectory(pybind11)
		else()
			# Get pybind11 with FetchContent
			include(FetchContent)

			FetchContent_Declare(
					pybind11-src
					GIT_REPOSITORY https://github.com/pybind/pybind11.git
					GIT_TAG        v2.5.0
			)
			if(${CMAKE_VERSION} VERSION_LESS 3.14)
				macro(FetchContent_MakeAvailable NAME)
					FetchContent_GetProperties(${NAME})
					if(NOT ${NAME}_POPULATED)
						FetchContent_Populate(${NAME})
						add_subdirectory(${${NAME}_SOURCE_DIR} ${${NAME}_BINARY_DIR})
					endif()
				endmacro()
			endif()
			FetchContent_MakeAvailable(pybind11-src)
		endif()

	endif()
endif()

set(LIB_SOURCE_FILES
		src/robot_state.cpp
        src/rtde.cpp
        src/dashboard_client.cpp
        src/dashboard_enums.cpp
        src/script_client.cpp
        src/rtde_control_interface.cpp
		src/rtde_receive_interface.cpp
		src/rtde_io_interface.cpp)

set(LIB_HEADER_FILES
        include/ur_rtde/rtde.h
        include/ur_rtde/rtde_utility.h
		include/ur_rtde/dashboard_enums.h
        include/ur_rtde/dashboard_client.h
        include/ur_rtde/robot_state.h
        include/ur_rtde/script_client.h
        include/ur_rtde/rtde_control_interface.h
		include/ur_rtde/rtde_control_interface_doc.h
		include/ur_rtde/rtde_receive_interface.h
		include/ur_rtde/rtde_receive_interface_doc.h
		include/ur_rtde/rtde_io_interface.h
		include/ur_rtde/rtde_io_interface_doc.h)

if(NOT DOC STREQUAL "OFF")
	add_subdirectory(doc)
endif()

if(${CODE})
	include(GenerateExportHeader)

	# Write the rtde_control script to a header file
	file(READ scripts/rtde_control.script RTDE_CONTROL_SCRIPT)
	set(header "const std::string NEW_LINE= \"\\n\"; const std::string QUOTATION = \"\\\"\"; std::string UR_SCRIPT = \"")
	string(REGEX REPLACE "\"" "\"+QUOTATION+\"" FILEVAR ${RTDE_CONTROL_SCRIPT})
	string(REGEX REPLACE "\\\n" "\" + NEW_LINE  + \n\"" FILEVAR ${FILEVAR})
	set(end "\";")
	file(WRITE include/ur_rtde/rtde_control_script.h "${header}${FILEVAR}${end}")

	add_library(rtde ${BUILD_TYPE} ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES})
	target_include_directories(rtde
			PUBLIC ${Boost_INCLUDE_DIRS}
			$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
			$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
			$<INSTALL_INTERFACE:include>)
	target_link_libraries(rtde PUBLIC
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY}
			${CMAKE_THREAD_LIBS_INIT})
	set_target_properties(rtde PROPERTIES 
			VERSION ${PROJECT_VERSION} 
			SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR})

	if(${PYTHON_BINDINGS})
		pybind11_add_module(rtde_control SHARED ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES}	src/rtde_python_bindings.cpp)
		target_include_directories(rtde_control
				PUBLIC ${Boost_INCLUDE_DIRS}
				$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
				$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
				$<INSTALL_INTERFACE:include>
				PRIVATE ${PYBIND11_INCLUDE_DIR}  # from project CMakeLists.txt
				PRIVATE ${pybind11_INCLUDE_DIR}  # from pybind11Config
				PRIVATE ${PYTHON_INCLUDE_DIRS})
		target_link_libraries(rtde_control PRIVATE
				#${PYTHON_LIBRARIES}
				${Boost_SYSTEM_LIBRARY}
				${Boost_THREAD_LIBRARY}
				${CMAKE_THREAD_LIBS_INIT})
                target_compile_definitions(rtde_control PRIVATE rtde_EXPORTS)

		pybind11_add_module(rtde_receive SHARED ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES} src/rtde_python_bindings.cpp)
		target_include_directories(rtde_receive
			PUBLIC ${Boost_INCLUDE_DIRS}
			$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
			$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
			$<INSTALL_INTERFACE:include>
			PRIVATE ${PYBIND11_INCLUDE_DIR}  # from project CMakeLists.txt
			PRIVATE ${pybind11_INCLUDE_DIR}  # from pybind11Config
			PRIVATE ${PYTHON_INCLUDE_DIRS})
		target_link_libraries(rtde_receive PRIVATE
				#${PYTHON_LIBRARIES}
				${Boost_SYSTEM_LIBRARY}
				${Boost_THREAD_LIBRARY})
                target_compile_definitions(rtde_receive PRIVATE rtde_EXPORTS)

		pybind11_add_module(rtde_io SHARED ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES} src/rtde_python_bindings.cpp)
		target_include_directories(rtde_io
				PUBLIC ${Boost_INCLUDE_DIRS}
				$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
				$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
				$<INSTALL_INTERFACE:include>
				PRIVATE ${PYBIND11_INCLUDE_DIR}  # from project CMakeLists.txt
				PRIVATE ${pybind11_INCLUDE_DIR}  # from pybind11Config
				PRIVATE ${PYTHON_INCLUDE_DIRS})
		target_link_libraries(rtde_io PRIVATE
				#${PYTHON_LIBRARIES}
				${Boost_SYSTEM_LIBRARY}
				${Boost_THREAD_LIBRARY})
		target_compile_definitions(rtde_io PRIVATE rtde_EXPORTS)

		pybind11_add_module(script_client SHARED ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES} src/rtde_python_bindings.cpp)
		target_include_directories(script_client
				PUBLIC ${Boost_INCLUDE_DIRS}
				$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
				$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
				$<INSTALL_INTERFACE:include>
				PRIVATE ${PYBIND11_INCLUDE_DIR}  # from project CMakeLists.txt
				PRIVATE ${pybind11_INCLUDE_DIR}  # from pybind11Config
				PRIVATE ${PYTHON_INCLUDE_DIRS})
			target_link_libraries(script_client PRIVATE
				#${PYTHON_LIBRARIES}
				${Boost_SYSTEM_LIBRARY}
				${Boost_THREAD_LIBRARY})
			target_compile_definitions(script_client PRIVATE rtde_EXPORTS)


		pybind11_add_module(dashboard_client SHARED ${LIB_SOURCE_FILES} ${LIB_HEADER_FILES} src/rtde_python_bindings.cpp)
		target_include_directories(dashboard_client
			PUBLIC ${Boost_INCLUDE_DIRS}
			$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
			$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
			$<INSTALL_INTERFACE:include>
			PRIVATE ${PYBIND11_INCLUDE_DIR}  # from project CMakeLists.txt
			PRIVATE ${pybind11_INCLUDE_DIR}  # from pybind11Config
			PRIVATE ${PYTHON_INCLUDE_DIRS})
		target_link_libraries(dashboard_client PRIVATE
			#${PYTHON_LIBRARIES}
			${Boost_SYSTEM_LIBRARY}
			${Boost_THREAD_LIBRARY})
		target_compile_definitions(dashboard_client PRIVATE rtde_EXPORTS)

	endif()

	if(${EXAMPLES})
		add_executable(servoj_example examples/cpp/servoj_example.cpp)
		target_include_directories(servoj_example PUBLIC ${Boost_INCLUDE_DIRS} $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
		target_link_libraries(servoj_example PRIVATE rtde ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

		add_executable(forcemode_example examples/cpp/forcemode_example.cpp)
		target_include_directories(forcemode_example PUBLIC ${Boost_INCLUDE_DIRS} $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
		target_link_libraries(forcemode_example PRIVATE rtde ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

		add_executable(speedj_example examples/cpp/speedj_example.cpp)
		target_include_directories(speedj_example PUBLIC ${Boost_INCLUDE_DIRS} $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
		target_link_libraries(speedj_example PRIVATE rtde ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

		add_executable(movej_path_with_blend_example examples/cpp/movej_path_with_blend_example.cpp)
		target_include_directories(movej_path_with_blend_example PUBLIC ${Boost_INCLUDE_DIRS} $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
		target_link_libraries(movej_path_with_blend_example PRIVATE rtde ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

		add_executable(io_example examples/cpp/io_example.cpp)
		target_include_directories(io_example PUBLIC ${Boost_INCLUDE_DIRS} $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
		target_link_libraries(io_example PRIVATE rtde ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY})

		set_target_properties(servoj_example forcemode_example speedj_example movej_path_with_blend_example io_example
				PROPERTIES
				RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bin"
				)
	endif()

	generate_export_header(rtde EXPORT_FILE_NAME ${CMAKE_CURRENT_SOURCE_DIR}/include/ur_rtde/rtde_export.h)

	add_library(ur_rtde::rtde ALIAS rtde)

	if(${EXAMPLES})
		add_executable(ur_rtde::servoj_example ALIAS servoj_example)
		add_executable(ur_rtde::forcemode_example ALIAS forcemode_example)
		add_executable(ur_rtde::speedj_example ALIAS speedj_example)
		add_executable(ur_rtde::movej_path_with_blend_example ALIAS movej_path_with_blend_example)
		add_executable(ur_rtde::io_example ALIAS io_example)
	endif()

	if (CMAKE_COMPILER_IS_GNUCXX)
		# Give error in Linux if library is not fully linked (like Windows)
		set_target_properties(rtde PROPERTIES LINK_FLAGS -Wl,--no-undefined)
	endif()

	if(NOT DEFINED LIB_INSTALL_DIR)
		set(LIB_INSTALL_DIR "lib")
	endif()
	if(NOT DEFINED BIN_INSTALL_DIR)
		set(BIN_INSTALL_DIR "bin")
	endif()
	if(NOT DEFINED INCLUDE_INSTALL_DIR)
		set(INCLUDE_INSTALL_DIR "include")
	else()
		set(INCLUDE_INSTALL_DIR "${INCLUDE_INSTALL_DIR}")
	endif()

	install(TARGETS rtde
			EXPORT RTDETargets
			LIBRARY DESTINATION ${LIB_INSTALL_DIR} COMPONENT ur_rtde_lib
			ARCHIVE DESTINATION ${LIB_INSTALL_DIR} COMPONENT ur_rtde_lib
			RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT ur_rtde_lib
			INCLUDES DESTINATION ${INCLUDE_INSTALL_DIR}
			)
	if(${PYTHON_BINDINGS})
		install(TARGETS rtde_control rtde_receive rtde_io dashboard_client script_client
				DESTINATION ${PYTHON_SITE_PACKAGES}
				COMPONENT ur_rtde-python)
	endif()

	install(
			FILES
			${LIB_HEADER_FILES}
			"${CMAKE_CURRENT_SOURCE_DIR}/include/ur_rtde/rtde_export.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/ur_rtde
			COMPONENT ur_rtde_dev
	)

	include(CMakePackageConfigHelpers)
	write_basic_package_version_file(
		"${CMAKE_CURRENT_BINARY_DIR}/ur_rtde/ur_rtdeConfigVersion.cmake"
		VERSION ${PROJECT_VERSION}
		COMPATIBILITY AnyNewerVersion
	)

=== doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED COMPONENTS dot)

#get_target_property(DOXY_DOT_PATH Doxygen::dot IMPORTED_LOCATION)
#get_filename_component(DOXY_DOT_PATH "${DOXY_DOT_PATH}" DIRECTORY)
#file(TO_NATIVE_PATH "${DOXY_DOT_PATH}" DOXY_DOT_PATH)

set(DOC_SRC "${PROJECT_SOURCE_DIR}/doc")
set(DOC_DEST "${PROJECT_BINARY_DIR}/doc/${DOC}")
set(DOC_TMP "${PROJECT_BINARY_DIR}/tmp/doc")

set(DOXY_BUILD_LATEX "NO")
if (${WERROR})
	set(DOXY_WARN_AS_ERR "YES")
else()
	set(DOXY_WARN_AS_ERR "NO")
endif()

# if the target is doxygen build only doxygen HTML
if(DOC STREQUAL "doxygen")
	set(DOXY_BUILD_HTML "YES")
	set(DOXY_BUILD_XML "NO")
	set(DOXY_OUTPUT_DIR "${DOC_DEST}")
# otherwise generate only XML and configure sphinx
else()
	if(DOC STREQUAL "html")
		set(EXTRA_PYTHON_MODULES "sphinx_rtd_theme")
	else()
		unset(EXTRA_PYTHON_MODULES)
	endif()

	set(DOXY_BUILD_HTML "NO")
	set(DOXY_BUILD_XML "YES")
	set(DOXY_OUTPUT_DIR "${DOC_TMP}/doxygen")

	# https://git.mel.vin/template/c/issues/50
	# https://bugzilla.gnome.org/show_bug.cgi?id=792676
	set(DOXY_WARN_AS_ERR "NO")
	
	find_package(PythonInterp 3.6 REQUIRED)
	include(find_python_module)

	# do not change the ENV, doesn't work with add_custom_target
	# https://cmake.org/Bug/view.php?id=5145
	if(ENV{PYTHONPATH})
		set(PYTHONPATH "$ENV{PYTHONPATH}")
	else()
		# PYTHONPATH disables defaults, manually append them
		execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
			"import sys; sys.stdout.write(':'.join(sys.path))"
			OUTPUT_VARIABLE PYTHONPATH)
	endif()

	foreach(module
			breathe
			sphinx
			${EXTRA_PYTHON_MODULES})
		string(TOUPPER "${module}" module_upper)
		find_python_module("${module}" "${module_upper}")
		set(PYTHONPATH "${${module_upper}_PATH}:${PYTHONPATH}")
	endforeach(module)

	if(${WERROR})
		set(SPHINX_WERROR "-W")
	else()
		unset(SPHINX_WERROR)
	endif()

	configure_file(
		"${DOC_SRC}/conf.py.in"
		"${DOC_TMP}/sphinx/conf.py"
		@ONLY)
endif()

configure_file(
	"${DOC_SRC}/doxyfile.in"
	"${DOC_TMP}/doxygen/doxyfile"
	@ONLY)

if(DOC STREQUAL "doxygen")
	add_custom_target(doc
		COMMAND Doxygen::doxygen "${DOC_TMP}/doxygen/doxyfile"
		COMMENT "Generating HTML API documentation with Doxygen")

	add_custom_command(TARGET doc POST_BUILD
		COMMAND ;
		COMMENT "Output at ${DOC_DEST}/html/index.html")
else()
	add_custom_target(doc
		COMMAND "${CMAKE_COMMAND}" -E echo
			"Generating Doxygen XML API documentation"
		COMMAND doxygen "${DOC_TMP}/doxygen/doxyfile"

		COMMAND "${CMAKE_COMMAND}" -E echo
			"Generating sphinx ${DOC} documentation"
		COMMAND "${CMAKE_COMMAND}" -E env "PYTHONPATH=${PYTHONPATH}"
			"${PYTHON_EXECUTABLE}" -m sphinx -b "${DOC}"
			-d "${DOC_TMP}/sphinx/doctrees" -j 4
			-c "${DOC_TMP}/sphinx" -q ${SPHINX_WERROR}
			"${DOC_SRC}" "${DOC_DEST}")

	add_custom_command(TARGET doc POST_BUILD
		COMMAND ;
		COMMENT "Output at ${DOC_DEST}")
endif()

=== examples/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(ur_rtde_examples)

set(DIR ${CMAKE_CURRENT_SOURCE_DIR})
message(STATUS "${DIR}")
find_package(ur_rtde REQUIRED PATHS "${DIR}/../../Build/ur_rtde" "${DIR}/../../build/ur_rtde")

add_executable(forcemode_example forcemode_example.cpp)
target_link_libraries(forcemode_example PUBLIC ur_rtde::rtde)

add_executable(io io_example.cpp)
target_link_libraries(io PUBLIC ur_rtde::rtde)

add_executable(movej_path_with_blend movej_path_with_blend_example.cpp)
target_link_libraries(movej_path_with_blend PUBLIC ur_rtde::rtde)

add_executable(servoj servoj_example.cpp)
target_link_libraries(servoj PUBLIC ur_rtde::rtde)

add_executable(speedj speedj_example.cpp)
target_link_libraries(speedj PUBLIC ur_rtde::rtde)

=== debian/changelog ===
ur-rtde (1.2.4-4) focal; urgency=medium

  [ Anders Prier Lindvig ]
  * Output of connection status is now optional through a verbose flag + updated README

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Thu, 16 Jul 2020 09:54:58 +0200

ur-rtde (1.2.4-3) focal; urgency=medium

  * initial focal Release 

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Wed, 15 Jul 2020 12:38:45 +0200

ur-rtde (1.2.4-2) focal; urgency=medium

  * initial debian Release 

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Wed, 15 Jul 2020 12:38:45 +0200

ur-rtde (1.2.4-1) focal; urgency=medium

  [ Anders Prier Lindvig ]
  * Initial commit of UR RTDE project
  * Updated .gitignore to not include build folders
  * Retrieval of joint Q working
  * Rewrote ur_rtde to rely on boost only, implemented logic for receiving data
  * Add .gitlab-ci.yml
  * Update .gitlab-ci.yml
  * Add README.md
  * Implemented ability to send data to the controller + client
  * Implemented a dashboard client and initial RobotState class
  * Implemented a control interface and script client, 
    made RobotState thread-safe
  * Updated receive client to use new RobotState
  * Implemented speed and servo functions
  * Removed command queue, since not necessary
  * Reorganized project with src and include 
    and added doxy+sphinx built documentation
  * Added fix for building documentation with CI
  * Removed specific python version requirement
  * Add link to documentation in readme
  * Minor cleanup of RTDE class
  * Small update to how the doc. is shown
  * Implemented std and tool digital output functions
  * Added more files to the documentation + logo
  * Implemented a RTDE receive interface with documentation
  * Added some examples
  * Update README.md
  * The script is now compiled as a header, 
    to avoid file path issues and performance
  * If no vars are specified for RTDEReceiveInterface constructor 
    all vars are transmitted
  * Implement python bindings for RTDE Control and Receive Interface + doc

  [ Thomas Nicky Thulesen ]
  * Implemented target exports in CMake and tested on Windows.
  * Added include directories for the python libraries.
  * Added linking to thread library again.

  [ Anders Prier Lindvig ]
  * Made python bindings optional + added install target for python libraries
  * Python bindings off by default
  * Python bindings off by default for docs
  * Updated documentation of RTDEControlInterface
  * Added animation of force mode example

  [ Thomas Nicky Thulesen ]
  * Fixing compilation on Windows.
  * Fixed spelling mistake.
  * Fixed Windows exports.

  [ Anders Prier Lindvig ]
  * Added a servoj example
  * Changed send/receive protocol logic
  * Python 2.X is now supported + updated README
  * New servo impl. + added return status and timeout functionality
  * Added MoveL with path example and Updated servo example in doc
  * Added MoveJ with path example
  * Update README.md
  * Update README.md
  * Add LICENSE
  * Added installation to documentation and updated README
  * Impl. threaded speed movements, updated servo impl + documentation
  * Implemented ability to set payload and CoG
  * Implemented teach_mode and force mode gain and damping parameters
  * Implemented ability to set the speed slider
  * Implemented analog voltage and current functions 
    + RobotState are no longer inline
  * Update README.md
  * Added a CMake example to doc

  [ Thomas Nicky Thulesen ]
  * Made it possible for the user to customize the install directories.

  [ Anders Prier Lindvig ]
  * Increased execution timeout period
  * Added ur_rtde namespace for all classes 
    + made some function not avail on CB3
  * Fixed doc to work with namespace
  * Added Windows instructions to doc.
  * Changed highlighting for example in doc
  * Added missing return values to functions
  * Deleted the generated rtde_control_script header
  * Implemented ability to get robot status 
    + termination of running scripts before sending a new
  * Update README.md
  * Connection loss is now handled safely, 
    impl. status + reconnect, reported in #6
  * Added tip for testing to doc
  * New IO interface, add. connection safety and custom script functions
  * Made python bindings for the RTDE IO interface + doc

  [ Nathan Quinn ]
  * Added missing return statement in RTDERecieveInterface::reconnect()

  [ Anders Prier Lindvig ]
  * Implemented a servoL function as requested by Inigo
  * Fixed typo in RTDEIOInterface.
  * Make sure doc uses Python3 Interpreter
  * Revert to deprecated FindPythonInterp for doc
  * Update README.md
  * Added exception handling for connect() function
  * Global interpreter lock (GIL) is now released on function calls, 
    which allows for Python multithreading

  [ Kasper Høj Lorenzen ]
  * Removed warnings and updated install

  [ Anders Prier Lindvig ]
  * Update .gitlab-ci.yml
  * Impl. tool_contact, get_actual_joint_positions_history, 
    get_steptime, get_target_waypoint + new logic for control version
  * Reception of data now works again, missing ID message offset, 
    after a code cleanup

  [ Iñigo Iturrate San Juan ]
  * Added missing python bindings for new functions

  [ Anders Prier Lindvig ]
  * Updated tool_contact function, to use UR pose array in script

  [ Iñigo Iturrate San Juan ]
  * Added missing python bindings for teach mode.

  [ Anders Prier Lindvig ]
  * Allowed maximum values and added default arguments
    for velocity and acceleration
  * Added clearing of cmd register, before sending control script
  * pybind11 will now be found, if installed by pip
  * Updated documentation with macOS instructions + new pip install for pybind11
  * Update README.md
  * Make sure command register are cleared when initializing
  * Added CI pipeline for building and uploading to PyPi
  * Updated documentation and readme, with pip install option
  * Added building of wheel for Python 2.7

  [ scholle ]
  * add bidirectional communication in dashboard client

  [ Anders Prier Lindvig ]


=== debian/control ===
Source: ur-rtde
Priority: optional
Maintainer: Anders Prier Lindvig <anpl@mmmi.sdu.dk>
Build-Depends: 
  debhelper (>= 10), 
  cmake(>= 3.5), 
  libboost-system-dev (>= 1.54), 
  libboost-thread-dev (>= 1.54), 
Standards-Version: 4.1.2
Section: libs
Homepage: https://sdurobotics.gitlab.io/ur_rtde/
Vcs-Git: https://gitlab.com/sdurobotics/ur_rtde.git
Vcs-Browser: https://gitlab.com/sdurobotics/ur_rtde

Package: librtde
Architecture: amd64
Multi-Arch: same
Depends: 
 ${shlibs:Depends}, 
 ${misc:Depends}
Description: Interface for UR robots
 A C++ interface for sending and receiving data to/from a UR robot using the
 Real-Time Data Exchange (RTDE) interface of the robot.

Package: librtde-dev
Section: libdevel
Architecture: amd64
Multi-Arch: same
Depends: 
 librtde (=${binary:Version}), 
 ${misc:Depends}
Description: Development library for ur-rtde.
 The Development library for ur-rtde.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 0
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	# Ubuntu 16
	#dh $@ --parallel --buildsystem=cmake --builddirectory=Build
	# Newer then ubuntu 16
	dh $@ --buildsystem=cmake --builddirectory=Build 

override_dh_auto_configure:
	dh_auto_configure -- \
        -DLIB_INSTALL_DIR=/usr/lib/$(DEB_TARGET_MULTIARCH) \
        -DPYTHON_BINDINGS=OFF

override_dh_clean:
	dh_clean
	$(RM) -r Build
	$(RM) include/ur_rtde/rtde_control_script.h
	$(RM) -r bin
	$(RM) -r debian/.debhelper
	$(RM) -r debian/libur-rtde
	$(RM) debian/libur-rtde.substvars
	$(RM) debian/libur-rtde.debhelper.log

override_dh_shlibdeps:
	LD_LIBRARY_PATH=$(DESTDIR)/usr/lib/$(DEB_TARGET_MULTIARCH):$$LD_LIBRARY_PATH dh_shlibdeps -l$(DESTDIR)/usr/lib/$(DEB_TARGET_MULTIARCH) -a
